package com.loafle.overflow.container.server;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.annotation.Resource;

import com.loafle.commons.server.Server;
import com.loafle.overflow.container.Container;

import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.ChannelFuture;

/**
 * ContainerServer
 */
public class ContainerServer extends Server {
  @Resource(name=Container.PIDFILE_PATH)
  private String pidFilePath;

  private int portNumber;

  public ContainerServer() {
  }

  public void setPidFilePath(String pidFilePath) {
    this.pidFilePath = pidFilePath;
  }

  protected ChannelFuture bind(ServerBootstrap serverBootstrap) throws Exception {
    ChannelFuture cf = null;

    for (int i = 60000; i < 61000; i++) {
      try {
        cf = serverBootstrap.bind("127.0.0.1", i).sync();
        this.portNumber = i;
        break;
      } catch (Exception e) {
        System.out.println(e);
        continue;
      }
    }

    if (null == cf) {
      throw new Exception("There is not available port");
    }

    try {
      FileOutputStream outputStream = new FileOutputStream(this.pidFilePath);
      outputStream.write(Integer.toString(this.portNumber).getBytes());
      outputStream.close();
    } catch (IOException e) {
      throw e;
    }

    return cf;
  }

  @Override
  protected void init() throws Exception {

  }

  @Override
  protected void onStart() throws Exception {

  }

  @Override
  protected void onStop() throws Exception {
    try {
      File f = new File(this.pidFilePath);
      f.delete();
    } catch (Exception e) {
      throw e;
    }
  }

  @Override
  protected void destroy() throws Exception {

  }
}